import copy
import random
import numpy as np


class MachineAssignment(object):
    """
    : Machine Assignmet
    """

    def __init__(self, data, data2, overview, job_n, **kwargs):
        """
        :param data:
        :param data2:
        :param overview:
        :param job_n:
        """
        self.data = data
        self.data2 = data2
        self.overview = overview
        self.job_n = job_n
        self.shuffle = kwargs.get("shuffle", None)

    def localization(self):
        """
        Machine assignment by localization based on Kacem et al.
        :return:
        """
        times = copy.deepcopy(self.data)
        mach = {}
        if not self.shuffle:
            for i in range(self.job_n):
                mach_temp = []
                job = i+1
                op = len(self.overview[i][0])
                for j in range(1, op+1):
                    minm = np.inf
                    temp = None
                    for m in self.data2[(job, j)]:
                        if times[(job, j, m)] < minm:
                            minm = times[(job, j, m)]
                            temp = m
                    mach_temp.append(temp)

                    for k in range(j+1, op+1):
                        try:
                            times[(job, k, temp)] = times[(job, k, temp)] + times[(job, j, temp)]
                        except KeyError:
                            pass#times[(job, k, temp)] = 999
                    for k in range(job+1, self.job_n+1):
                        op = len(self.overview[k-1][0])
                        for l in range(1, op+1):
                            try:
                                times[(k, l, temp)] = times[(k, l, temp)] + times[(job, j, temp)]
                            except KeyError:
                                pass#times[(k, l, temp)] = 999
                mach[job-1] = mach_temp

        else:
            permutedJobs = list(range(self.job_n))
            random.shuffle(permutedJobs)
            for job in permutedJobs:
                mach_temp = []
                op = len(self.overview[job][0])
                for j in range(1, op + 1):
                    minm = np.inf
                    temp = None
                    for m in self.data2[(job+1, j)]:
                        if times[(job+1, j, m)] < minm:
                            minm = times[(job+1, j, m)]
                            temp = m
                    mach_temp.append(temp)

                    for k in range(j + 1, op + 1):
                        try:
                            times[(job+1, k, temp)] = times[(job+1, k, temp)] + times[(job+1, j, temp)]
                        except KeyError:
                            pass #times[(job+1, k, temp)] = 999
                    for k in [x for x in permutedJobs if x not in [job]]:
                        op = len(self.overview[k][0])
                        for l in range(1, op + 1):
                            try:
                                times[(k+1, l, temp)] = times[(k+1, l, temp)] + times[(job+1, j, temp)]
                            except KeyError:
                                pass #times[(k+1, l, temp)] = 999
                mach[job] = mach_temp

        mach2 = []
        for i in range(0, self.job_n):
            mach2.append(mach[i])

        return mach2

    def roulette(self):
        """
        Roulette wheel selection
        :return:
        """
        mach = []
        for key in sorted(self.data2.keys()):
            if len(self.data2[key]) > 1:
                j = key[0]
                o = key[1]
                rel = dict((x, self.data[x]) for x in self.data.keys() if x[0] == j and x[1] == o)
                if len(set(rel.values())) > 1:
                    rel_sorted = sorted(rel, key=rel.get, reverse=True)
                    n = len(rel_sorted)
                    sum_fits = n * self.data[rel_sorted[0]] - sum(self.data[ind] for ind in rel.keys())
                    u = random.random() * sum_fits
                    sum_ = 0
                    for ind in rel_sorted:
                        sum_ += self.data[rel_sorted[0]] - self.data[ind]
                        if sum_ > u:
                            mach.append(ind[2])
                            break
                else:
                    m = random.sample(self.data2[key], 1)[0]
                    mach.append(m)

            else:
                m = self.data2[key][0]
                mach.append(m)

        temp = copy.deepcopy(mach)
        mach2 = []
        for i in range(0, self.job_n):
            mach2.append(list(temp[:self.overview[i][0][-1]]))
            del temp[:self.overview[i][0][-1]]

        return mach2

    def wang(self):
        """
        Based on Wang et al.
        :return:
        """

        mach = []
        for key in sorted(self.data2.keys()):
            if len(self.data2[key]) > 1:
                m1, m2 = np.random.choice(self.data2[key], 2, replace=False)
                p = np.random.uniform()
                if p < 0.8:
                    if self.data[(key[0], key[1], m1)] < self.data[(key[0], key[1], m2)]:
                        mach.append(m1)
                    else:
                        mach.append(m2)
                else:
                    if self.data[(key[0], key[1], m1)] > self.data[(key[0], key[1], m2)]:
                        mach.append(m1)
                    else:
                        mach.append(m2)
            else:
                m = self.data2[key][0]
                mach.append(m)

        temp = mach[:]  # copy.deepcopy(mach)
        mach2 = []
        for i in range(0, self.job_n):
            mach2.append(list(temp[:self.overview[i][0][-1]]))
            del temp[:self.overview[i][0][-1]]

        return mach2
