import numpy as np


def score(state,data,overview):
    """
    : Calculation of the makespan
    """

    state = [x for x in state if x not in [(0,0,0),('f','f','f')]]
    cached_idx = {entry: idx for idx, entry in enumerate(state)}
    operation_pred = {}
    machine_pred = {}
    Op_start_time = {}
    Op_start_time_L = {}
    completion = {}
    operation_suc = {}
    machine_suc = {}

    for entry in state:
        mach = entry[2]
        opt = entry[1]
        job = entry[0]
        ind = cached_idx[entry]

        if (opt > 1):
            operation_pred[entry] = [x for x in state if x[0]==job and x[1]==opt-1][-1]
        else:
            operation_pred[entry] = []
        if (ind > 0):
            try:
                machine_pred[entry] = [x for x in state if x[2]==mach and cached_idx[x]<ind][-1]
            except IndexError:
                machine_pred[entry] = []
        else:
            machine_pred[entry] = []
    
    for entry in state:
        mach = entry[2]
        opt = entry[1]
        job = entry[0]
        ind = cached_idx[entry]

        if (opt < overview[job-1][0][-1]):
            operation_suc[entry] = [x for x in state if x[0]==job and x[1]==opt+1][0]
        else:
            operation_suc[entry] = []
        if (ind > 0):
            try:
                machine_suc[entry] = [x for x in state if x[2]==mach and cached_idx[x]>ind][0]
            except IndexError:
                machine_suc[entry] = []
        else:
            machine_suc[entry] = []
            
    for entry in state:

        X = operation_pred[entry]
        Y = machine_pred[entry]

        if (X==[] and Y==[]):
            Op_start_time[entry] = 0

        elif Y==[] and X!=[]:
            Op_start_time[entry] = np.max([Op_start_time[X]+data[X],0])
        elif X==[] and Y!=[]:
            Op_start_time[entry] = np.max([0, Op_start_time[Y]+data[Y]])
        else:
            Op_start_time[entry] = np.max([Op_start_time[X]+data[X], Op_start_time[Y]+data[Y]])
            
    
    for i in range(len(overview)):
        j = overview[i][0][-1]
        entry = [x for x in state if x[0]==i+1 and x[1]==j][0]
        completion[entry] = Op_start_time[entry] + data[entry]        
    
    makespan = np.max(list(completion.values()))
    
    
    for entry in reversed(state):
        X = operation_suc[entry]
        Y = machine_suc[entry]
        if (X==[] and Y==[]):
            Op_start_time_L[entry] = makespan - data[entry]
        elif Y==[] and X!=[]:
            Op_start_time_L[entry] = np.min([Op_start_time_L[X],makespan]) - data[entry]
        elif X==[] and Y!=[]:
            Op_start_time_L[entry] = np.min([makespan, Op_start_time_L[Y]]) - data[entry]
        else:
            Op_start_time_L[entry] = np.min([Op_start_time_L[X], Op_start_time_L[Y]]) - data[entry]
            
    A = [x for x in state if x not in [(0,0,0),('f','f','f')]]
    cp = []
    for entry in A:
        if Op_start_time[entry]-Op_start_time_L[entry]==0:
            cp.append(entry)
    
    temp = []
    for x in cp:
        temp.append(Op_start_time[x]+data[x])
        
    return cp, makespan, max(temp)

