import numpy as np
import copy


def recombination(overview, job_n, p1, p2):
        """
        : Recombination operators for the
        : machine assignment sequence and
        : the operation sequence
        """

        seq1 = p1[0][0]
        seq2 = p2[0][0]

        n = np.random.randint(1,job_n-1,1)
        set1 = np.random.choice(range(1,job_n+1),n, replace = False)
        set2 = [i for i in range(1,job_n+1) if i not in set1]
        child1 = np.zeros(len(seq1), dtype=int)
        child2 = np.zeros(len(seq2), dtype=int)

        for i in range(len(seq1)):
            x = seq1[i]
            if x in set1:
                child1[i] = x

        for i in range(len(seq2)):
            x = seq2[i]
            if x in set2:
                child2[i] = x

        temp1 = [k for k in seq1 if k in set1]
        temp2 = [k for k in seq2 if k in set2]

        for x in child1:
            if x == 0:
                try:
                    ind = np.where(child1 == 0)[0][0]
                    child1[ind] = temp2[0]
                    del temp2[0]
                except IndexError:
                    pass

        for x in child2:
            if x == 0:
                try:
                    ind = np.where(child2 == 0)[0][0]
                    child2[ind] = temp1[0]
                    del temp1[0]
                except IndexError:
                    pass

        p1[0][0] = child1.tolist()
        p2[0][0] = child2.tolist()

        mach1 = [item for sublist in p1[0][1] for item in sublist]
        mach2 = [item for sublist in p2[0][1] for item in sublist]
        temp = np.random.randint(2, size=len(mach1)).tolist()
        ones = [i for i, j in enumerate(temp) if j == 1]

        mach1_new = copy.deepcopy(mach1)
        mach2_new = copy.deepcopy(mach2)
        for ind in ones:
            mach1_new[ind] = mach2[ind]
            mach2_new[ind] = mach1[ind]

        temp = mach1_new[:]
        mach_ch1 = []
        for i in range(0, job_n):
            mach_ch1.append(tuple(temp[:overview[i][0][-1]]))
            del temp[:overview[i][0][-1]]

        temp = mach2_new[:]
        mach_ch2 = []
        for i in range(0, job_n):
            mach_ch2.append(tuple(temp[:overview[i][0][-1]]))
            del temp[:overview[i][0][-1]]

        p1[0][1] = mach_ch1
        p2[0][1] = mach_ch2

        return p1, p2
