from . import Makespan


def score(data, overview, max_mach, p):
    """
    : Scoring function for the FJSSP
    : It computes the makespan, the 
    : total machine workload, and the
    : critical workload
    """
    sch = []
    seq = p[0][0]
    mach = p[0][1]
    t = []
    for x in seq:
        if x not in t:
            sch.append((x, 1, mach[x - 1][0]))
            t.append(x)
        else:
            t.append(x)
            m = t.count(x)
            sch.append((x, m, mach[x - 1][m - 1]))

    _, _, makespan = Makespan.score(sch, data, overview)

    nodes = sch
    workload = []
    for i in range(1, max_mach + 1):
        processes = [node for node in nodes if node[2] == i]
        total_proc_time = sum([data[i] for i in processes])
        workload.append(total_proc_time)
    maxworkload = max(workload)

    nodes = sch
    total_workload = 0
    for i in range(1, max_mach + 1):
        processes = [node for node in nodes if node[2] == i]
        total_proc_time = sum([data[i] for i in processes])
        total_workload += total_proc_time

    return makespan, total_workload, maxworkload
